import java.awt.*;
import java.util.*;

public class Drawiter extends Treeiter {
  Graphics g;
  int xo, yo, gxs, gys;
  int refl=0;
  Treeview tv;
  final static Color rulecolor = new Color(255,200,150);
  final static Color bagcolor = new Color(200,200,255);
  Drawiter(Graphics gr, int x, int y, int xs, int ys, Treeview t) {
    g = gr; xo = x; yo = y; gxs = xs; gys = ys; tv = t;
  };
  Code atom(Atom a, int x, int y) {
    //if(x+a.xs<xo || y+a.ys<yo || x>xo+gxs || y>yo+gys) return null; // see paint getClip?
    shared(a,x-xo,y-yo);
    if(a.cached!=null) {
      g.drawImage(a.cached,x-xo,y-yo,null,tv.darea);
    } else {
      g.setColor(Color.black);
      g.drawString(a.s,x-xo+1,y-yo+g.getFontMetrics().getMaxAscent());
    };
    unshared(a);
    return null;
  };
  void bagpre(Bag b, int x, int y) {
    x-=xo; y-=yo;
    shared(b,x,y);
    fatborder(bagcolor,x,y,b);
  };
  void bagpost(Bag b, int x, int y) { unshared(b); };
  void treepre(Tree t, int x, int y) { shared(t,x-xo,y-yo); };
  Code treemid(Tree t, Code c, int x, int y, int xdot) {
    dotted_line(xdot-xo,midy-yo,xdot-xo+t.dotted_line_space,midy-yo,Color.gray,2);
    return null;
  };
  void treepost(Tree t, int x, int y, int xdot, int first, int last) {
    if(t.c.size()>1) dotted_line(xdot-xo,first-yo,xdot-xo,last-yo,Color.gray,2);
    unshared(t);
  };
  void rulepre(Rules r, int x, int y) {
    x-=xo; y-=yo;
    shared(r,x,y);
    if(r.e!=null) fatborder(rulecolor,x,y,r);
  };
  Code rulemidp(Rules r, Code c, int x, int y) {
    fatline(r.xs-r.rule_space*2,x-xo+r.rule_space,y-yo-r.rule_space/2-2,3,Color.black);
    return null;
  };
  Code rulemide(Rules r, Code c, int x, int y) {
    y -= r.patexp_space/2+1;
    dotted_line(x-xo+r.rule_space,y-yo,x-xo+r.xs-r.rule_space,y-yo,Color.black,4);
    return null;
  };
  void rulepost(Rules r, int x, int y) {
    fatline(r.xs-r.rule_space*2,x-xo+r.rule_space,y-yo-r.rule_space+r.ys,3,Color.black);
    unshared(r);
  };
  void fatborder(Color c, int x, int y, Code a) {
    g.setColor(c);
    g.drawRect(x,y,a.xs,a.ys);
    g.drawRect(x+1,y+1,a.xs-2,a.ys-2);
    g.drawRect(x+2,y+2,a.xs-4,a.ys-4);
    g.drawRect(x+3,y+3,a.xs-6,a.ys-6);
  }
  void fatline(int width, int x, int y, int n, Color col) {
    g.setColor(col);
    while(n--!=0) g.drawLine(x,y,x+width,y++);
  };
  void unshared(Code c) {
    if(c.refc>1) refl--;
  };
  void shared(Code c, int x, int y) {
    //g.setColor(Color.red); g.drawRect(x,y,c.xs,c.ys);
    if(c.refc>1 || c.isexample) {
      refl++;
      int a = Math.max(255-refl*16,150);
      int b = Math.max(200-refl*16,100);
      g.setColor(c.isexample?new Color(a,b,0):new Color(a,a,a));
      g.fillRect(x,y,c.xs,c.ys);
    };
  };
  void dotted_line(int x, int y, int ex, int ey, Color c, int step) {
    int stepx = (x==ex)?0:step;
    int stepy = (y==ey)?0:step;
    g.setColor(c);
    for(;x<=ex && y<=ey;x+=stepx,y+=stepy) g.drawLine(x,y,x,y);
  };
}


